unit Main;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.Buttons, Vcl.ExtCtrls;

type
  TForm1 = class(TForm)
    LabeledEdit1: TLabeledEdit;
    BitBtn1: TBitBtn;
    LabeledEdit2: TLabeledEdit;
    BitBtn2: TBitBtn;
    Memo1: TMemo;
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

uses system.Math;

function arsinhf(x : extended): extended;
const
  k = 1000000000;
var
  i: integer;
  ar, arb, f, v: extended;
begin
  i := 1;
  v := - 1 / 2;
  f := x * x * x;
  ar := x + v * f / (i * 2 + 1);
  repeat
    inc(i);
    arb := ar;
    f := f * x * x;
    v := - v * (i * 2 - 1) / (i * 2);
    ar := ar + v * f / (i * 2 + 1);
  until (arb = ar) or (i > k);
  result := ar;
  if k < i then
    Form1.Memo1.Lines.Append('  Loops ɒB܂B ');
  Form1.Memo1.Lines.Append('  Loops = ' + intTostr(i));
end;

function artanhf(x : extended): extended;
const
  k = 1000000000;
var
  i : integer;
  ar, arb, f, v: extended;
begin
  f := x;
  ar := x;
  i := 1;
  repeat
    arb := ar;
    f := f * x * x;
    v := i * 2 + 1;
    ar := ar + f / v;
    inc(i);
  until (arb = ar) or (i > k);
  result := ar;
  if k < i then
    Form1.Memo1.Lines.Append('  Loops ɒB܂B ');
  Form1.Memo1.Lines.Append('  Loops = ' + intTostr(i));
end;

function arcoshf(x : extended): extended;
const
  k = 1000000000;
var
  i : integer;
  ar, arb, f, v: extended;
begin
  if x = 1 then begin
    result := 0;
    exit;
  end;
  ar := ln(2 * x);
  f := x * x;
  v := 1 / 2;
  i := 1;
  ar := ar - v / f / (i * 2);
  repeat
    inc(i);
    arb := ar;
    f := f * x * x;
    v := v * (i * 2 - 1) / (i * 2);
    ar := ar - v / f / (i * 2);
  until (arb = ar) or (i > k);
  result := ar;
  if k < i then
    Form1.Memo1.Lines.Append('  Loops ɒB܂B ');
  Form1.Memo1.Lines.Append('  Loops = ' + intTostr(i));
end;

procedure TForm1.BitBtn1Click(Sender: TObject);
var
  ch : integer;
  x, ar : extended;
begin
  val(labelededit1.Text, x, ch);
  if ch <> 0 then begin
    application.MessageBox('͒lɊԈႢ܂B','',0);
    exit;
  end;
  if abs(x) >= 1 then begin
    application.MessageBox('X̐Βl͂PȉɂĉB','',0);
    exit;
  end;
  memo1.Clear;
  memo1.Lines.Append('WJɂvZ');
  ar := arsinhf(x);
  memo1.Lines.Append('@@arcsinh = ' + floatTostr(ar));
  ar := artanhf(x);
  memo1.Lines.Append('@@arctanh = ' + floatTostr(ar));
  memo1.Lines.Append('MathɂvZ');
  ar := arcsinh(x);
//  ar := ln(x + sqrt(x * x + 1));
  memo1.Lines.Append('@@arsinh = ' + floatTostr(ar));
  ar := arctanh(x);
//  ar := ln((1 + x)/ (1 - x)) / 2;
  memo1.Lines.Append('@@artanh = ' + floatTostr(ar));
end;

procedure TForm1.BitBtn2Click(Sender: TObject);
var
  ch : integer;
  x, ar : extended;
begin
  val(labelededit2.Text, x, ch);
  if ch <> 0 then begin
    application.MessageBox('͒lɊԈႢ܂B','',0);
    exit;
  end;
  if abs(x) < 1 then begin
    application.MessageBox('X̐Βl͂P傫ĉB','',0);
    exit;
  end;
  memo1.Clear;
  memo1.Lines.Append('WJɂvZ');
  ar := arcoshf(x);
  memo1.Lines.Append('@@arcosh = ' + floatTostr(ar));
  memo1.Lines.Append('MathɂvZ');
  ar := arccosh(x);
//  ar := ln(x + sqrt(x + 1) * sqrt(x - 1));
  memo1.Lines.Append('@@arcosh = ' + floatTostr(ar));
  end;
end.
